from django.db import models
from django.utils import timezone

# Create your models here.

# isCurrent=1 是当前成员, 0 旧成员；
# member_type = 0 academic 老师, 1 engineer, 2 研究生 Master, 3 博士生PHD;


class User(models.Model):
    userID = models.BigIntegerField(primary_key=True)
    name = models.CharField(max_length=50)
    pwd = models.CharField(max_length=100)
    name_hanzi = models.CharField(max_length=100)
    member_type = models.IntegerField(default=2)
    isCurrent = models.IntegerField(default=1)
    identity = models.CharField(max_length=1, default='0')
    introduction = models.TextField(default="No Information")
    score = models.IntegerField(default=0)
    scoreUsed = models.IntegerField(default=0)
    mailAddress = models.CharField(max_length=100, default='mail@example.com')

    def is_admin(self):
        return self.identity


class Publications(models.Model):
    pubID = models.BigIntegerField(primary_key=True)
    title = models.CharField(max_length=1000)
    link = models.CharField(max_length=1000)
    authors = models.CharField(max_length=1000)
    messages = models.CharField(max_length=100, default='no information')
    publishType = models.CharField(max_length=100,default=' ')
    journalname=models.CharField(max_length=1000,default=' ')
    date = models.DateField(default=timezone.now)
    indexType = models.CharField(max_length=100,default=' ')
    uploadByUser = models.CharField(max_length=50,default='no records')
    isOpen = models.CharField(max_length=5, default='1')


class PubToUser(models.Model):
    pubID = models.BigIntegerField()
    username = models.CharField(max_length=50)


class Articles(models.Model):
    articleID = models.BigIntegerField(primary_key=True)
    authorID = models.IntegerField()
    title = models.CharField(max_length=500, default='null')
    content = models.TextField()
    publish = models.CharField(max_length=5, default='0')
    editDateTime = models.DateField(default=timezone.now)
    isPrivate = models.CharField(max_length=5, default='0')
    attachment = models.CharField(max_length=1000, default='nofile')


class ScoreRecords(models.Model):
    recordID = models.BigIntegerField(primary_key=True)
    userID = models.BigIntegerField()
    username = models.CharField(max_length=50,default='null')
    reason = models.TextField(default='no reason')
    editDate = models.DateField(default=timezone.now)


class Bugs(models.Model):
    owner = models.CharField(max_length=50)
    identifier = models.CharField(max_length=50)
    bugType = models.CharField(max_length=20)
    datetime = models.DateField(default=timezone.now)
    description = models.TextField()
    url = models.CharField(max_length=1000)

