from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, Http404
from .models import *
from django.views import generic
from django.db.models.aggregates import Count
from django.db.models import Count
# Create your views here.


def index(request):
    user_list = User.objects.filter(isCurrent=1, identity='0').all()
    user_type_list = {"Academic STAFF": [], "Phd": [], "Master": [], "Engineer STAFF": []}
    for u in user_list:
        if u.member_type == 0:
            u.member_type = "Academic STAFF"
        else:
            if u.member_type == 1:
                u.member_type = "Engineer STAFF"
            else:
                if u.member_type == 2:
                    u.member_type = "Phd"
                else:
                    u.member_type = "Master"
        member_type = u.member_type
        if member_type in user_type_list.keys():
            user_type_list[member_type].append(u)
        else:
            user_type_list[member_type] = [u]

    publication_list = Publications.objects.order_by('-date')
    publication_year_list = {}
    for pub in publication_list:
        year = str(pub.date)[0:4]
        pub.date = str(pub.date)[5:10]
        pub.link = pub.link.split('/')[-1]
        print(pub.link)
        if year in publication_year_list.keys():
            publication_year_list[year].append(pub)
        else:
            publication_year_list[year] = [pub]

    bug_list = Bugs.objects.order_by('-datetime')
    cve_year_list = {}
    for cve in bug_list:
        year = str(cve.datetime)[0:4]
        cve.datetime = str(cve.datetime)[5:10]
        print(cve.datetime)
        if year in cve_year_list.keys():
            cve_year_list[year].append(cve)
        else:
            cve_year_list[year] = [cve]

    article_list = Articles.objects.order_by('-editDateTime')
    article_year_list = {}
    for art in article_list:
        year = str(art.editDateTime)[0:4]
        art.editDateTime = str(art.editDateTime)[5:10]
        u = User.objects.filter(userID=art.authorID).values('name')
        art.authorID = u[0]['name']
        if year in article_year_list.keys():
            article_year_list[year].append(art)
        else:
            article_year_list[year] = [art]
    context = {
        'user_type_list': user_type_list,
        'publication_year_list': publication_year_list,
        'cve_year_list': cve_year_list,
        'article_year_list': article_year_list,
    }
    return render(request, 'hunter/index.html', context)


def user(request, user_id):
    u = get_object_or_404(User, pk=user_id)
    return render(request, 'hunter/user.html', {'user': u})


def article(request, article_id):
    art = get_object_or_404(Articles, pk=article_id)
    return render(request, 'hunter/article.html', {'article': art})
